program SameStrings;
USES System, SysUtils;
{$R *.res}
const
   {  }
      SmallEnglishLetters=['a'..'z'];
      BigEnglishLetters=['A'..'Z'];
      EnglishLetters=SmallEnglishLetters+BigEnglishLetters;
   {  }
      SmallRussianLetters=[''..''];
      BigRussianLetters=[''..''];
      VowelSmallRussianLetters=['','','','','','','','','','']; {}
      RussianLetters=SmallRussianLetters+BigRussianLetters;
   {  }
      letters=EnglishLetters+RussianLetters;

function min(x, y: integer): integer;
begin
   if x<=y then result:=x else result:=y;
end;

function LowerCase(s: string): string;
var
   i, l: integer;
begin
   l:=length(s);
   for i:=1 to l do begin
      if s[i] in BigRussianLetters then s[i]:=chr(ord(s[i])-ord('')+ord(''))
      else if s[i] in BigEnglishLetters then s[i]:=chr(ord(s[i])-ord('A')+ord('a'));
   end;
   result:=s;
end;

function SameStrings0(const name1, name2: string; power: integer): integer;
var
   s1, s2, sub_string: ShortString;
   same, f, l0, l, OK, k: integer;
begin
   if length(name1)>=length(name2) then begin
      s1:=LowerCase(name1);
      s2:=LowerCase(name2);
   end
   else begin
      s2:=LowerCase(name1);
      s1:=LowerCase(name2);
   end;
   same:=0;
   result:=length(s2);
   if result=0 then exit;
   l:=min(power,length(s1));
   l0:=min(5, l);
   while l0>=1 do begin
      f:=1;
      while f<=l-l0+1 do begin
         sub_string[0]:=chr(l0);
         for k:=1 to l0 do sub_string[k]:=s1[k+f-1];
         OK:=pos(sub_string, s2);
         if OK<>0 then begin
            delete(s1, f, l0);
            delete(s2, OK, l0);
            inc(same, l0*min(5,l0));
            l:=min(l,length(s1));
            if l<l0 then begin
               l0:=l+1;
               break;
            end
            else dec(f);
         end;
         inc(f);
      end;
      dec(l0);
   end;
   result:=round(20*same/result);
end;

var
   f1, f2: text;
   name_file, name_query: string;
   threshold: integer;
   code: string;
   name: string;
   OK: boolean;
BEGIN
//c: query.txt answer.txt
//c:\query.txt
   assign(f1, ParamStr(1)+'\'+ParamStr(2));
   reset(f1);
   readln(f1, name_file);
   readln(f1, name_query);
   readln(f1, threshold);
   close(f1);
   OK:=true;
//   raise Exception.Create('100');
   try
   assign(f1, ParamStr(1)+'\'+name_file+'.txt'); reset(f1);
   assign(f2, ParamStr(1)+'\'+ParamStr(3)); rewrite(f2);
   while not eof(f1) do begin
      readln(f1, code);
      readln(f1, name);
      writeln(f2, code);
      writeln(f2, name);
      writeln(f2, SameStrings0(Trim(name_query), Trim(name), threshold));
   end;
   close(f2);
   close(f1);
   except
      on E: Exception do begin
         raise Exception.Create(E.Message+'   name="'+name+'"');
      end;
   end;
END.
